[[> :header]]

<ol class="breadcrumb">
  [[> :templateBreadcrumb uri=":Start" label="Home"]]
  [[> :templateBreadcrumb uri=":listParts" label="Parts"]]
</ol>

<semantic-query
  query='SELECT ?part_name WHERE
    {
      ?part ecrm:P3_has_note ?part_name .
      BIND(<[[urlParam "partiri"]]> as ?part)
     }'
  template="<h3>{{#each bindings}}{{part_name.value}}{{/each}}</h3>">
</semantic-query>


<bs-tab-container default-active-key="[[#if (urlParam "tab" )]][[urlParam "tab"]][[else]]details[[/if]]">
  <bs-row>
    <bs-col sm="2" sm-push="10" class="tab-bar">
      <semantic-link uri="[[urlParam "partiri"]]" class="btn btn-md btn-primary pull-right" style="margin-bottom:3px;">Edit</semantic-link>
    </bs-col>
    <bs-col sm="10" sm-pull="2" class="tab-bar">
      <bs-nav bs-style="tabs" >
        <bs-nav-item event-key="details">
          Details
        </bs-nav-item>

        <bs-nav-item event-key="regions">
          <semantic-query
            query='SELECT (COUNT(?region) as ?num_regions) WHERE {
              BIND(<[[urlParam "partiri"]]> as ?part)
              ?attribute_assignment
                sphaera:pageFrom ?page_from ;
                sphaera:pageTo ?page_to ;
                ecrm:P141_assigned/efrbroo:R15i_is_fragment_of? ?part ;
                ecrm:P140_assigned_attribute_to/^ecrm:P165_incorporates/^ecrm:P128_carries ?book .

              ?book efrbroo:R29i_was_reproduced_by/efrbroo:R30_produced/ecrm:P128_carries/ecrm:P106_is_composed_of ?page .
              ?page ecrm:P1_is_identified_by ?page_number .
              FILTER(?page_number >= ?page_from && ?page_number <= ?page_to)

              ?region crmDig:L49_is_primary_area_of ?page .
            }'
            template='{{#each bindings}}Regions ({{num_regions.value}}){{/each}}'
          >
          </semantic-query>
        </bs-nav-item>

        <bs-nav-item event-key="meta">
          <semantic-query query='SELECT (COUNT(?annotation) as ?num_annotations) WHERE {
            ?annotation a oa:Annotation ;
              oa:hasTarget ?part .
              BIND(<[[urlParam "partiri"]]> as ?part)
            }'
            template='{{#each bindings}}Annotations ({{num_annotations.value}}){{/each}}'
          ></semantic-query>
        </bs-nav-item>
      </bs-nav>
    </bs-col>
    <div class="content" style="clear:both;">
      <bs-tab-content animation="true">
        <bs-tab-pane event-key="details">
          <dl>

            <semantic-query
              query='SELECT ?custom_identifier WHERE {
                ?part ecrm:P1_is_identified_by ?identifier .
          			?identifier ecrm:P2_has_type sphaera:customIdentifier ;
          				ecrm:P3_has_note ?custom_identifier .
                BIND(<[[urlParam "partiri"]]> as ?part) .
              }'
              template='<dt>Custom Identifier</dt>{{#each bindings}}<dd>{{custom_identifier.value}}</dd>{{/each}}'>
            </semantic-query>

            <semantic-query
              query="SELECT ?part_title WHERE {
                ?part ecrm:PC01_is_domain_of ?has_title .
                ?has_title ecrm:PC02_has_range/ecrm:P3_has_note ?part_title ;
                  ecrm:P102.1_has_type sphType:primary .
                BIND(<[[urlParam "partiri"]]> as ?part) .
              }"
              template="<dt>Primary Title</dt>
              {{#each bindings}}
                <dd>
                  {{part_title.value}}
                </dd>
              {{/each}}"

            >
            </semantic-query>

            <semantic-query
              query='SELECT ?author ?author_name WHERE {
                ?part efrbroo:R17i_was_created_by/ecrm:PC01_is_domain_of ?carried_out_by .
                  ?carried_out_by a ecrm:PC14_carried_out_by ;
                    ecrm:PC02_has_range ?author .
                  ?author ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?author_label .
                  [[> :queryFormatName input="?author_label" output="?author_name"]]
                  BIND(<[[urlParam "partiri"]]> as ?part) .
              }'
              template='<dt>
                {{#each bindings}}
                  {{#if @first}}
                    {{#if @last}}
                      Creator
                    {{else}}
                      Creators{{/if}}
                    {{/if}}
                  {{/each}}
                </dt>
                {{#each bindings}}
                  <dd>
                    <semantic-link uri=":viewPerson" urlqueryparam-personiri="{{author.value}}">{{author_name.value}}</semantic-link>
                  </dd>
                {{/each}}'>
            </semantic-query>

            <!-- Books where the Part appears in -->
            <semantic-query
              query='SELECT DISTINCT ?attribute_assignment WHERE {
                ?book ecrm:P128_carries/ecrm:P165_incorporates/^ecrm:P140_assigned_attribute_to ?attribute_assignment .
                ?attribute_assignment ecrm:P141_assigned/[[> :queryPart]] ?part .
                BIND(<[[urlParam "partiri"]]> as ?part)
              }'
              template='<dt>
                Appears in
              </dt>'
            ></semantic-query>

            <dd>
              <semantic-table
                config='{
                  "query" : "SELECT DISTINCT
                    	?attribute_assignment
                    	?assigned_part
                    	?assigned_part_title
                    	?book
                    	?book_short_title
                      ?custom_identifier
                    	?date_published_text
                      ?fragment_original
                    	?is_fragment
                      ?is_adaption
                    	?part_title_in_book
                    	?part_type_label
                      ?page_from
                      ?page_from_page
                    	?translated_language
                    	(YEAR(?date_published_from) as ?year_published_from)
                    WHERE {

                      BIND(<[[urlParam "partiri"]]> as ?part)

                      ?book ecrm:P128_carries/ecrm:P165_incorporates/^ecrm:P140_assigned_attribute_to ?attribute_assignment ;
                        ecrm:P3_has_note ?book_short_title .

                      ?attribute_assignment ecrm:P141_assigned/[[> :queryPart]] ?part ;
                        ecrm:P141_assigned ?assigned_part .

                      OPTIONAL {
                        ?attribute_assignment sphaera:pageFrom ?page_from .
                      }

                      OPTIONAL {
                        ?page_from_page ecrm:P1_is_identified_by ?page_from .
                        ?book efrbroo:R29i_was_reproduced_by/efrbroo:R30_produced/ecrm:P128_carries/ecrm:P106_is_composed_of ?page_from_page .
                      }

                      ?assigned_part ecrm:P3_has_note ?assigned_part_title ;
                        efrbroo:R15i_is_fragment_of?/ecrm:P2_has_type ?part_type .
                    	?part_type ecrm:P3_has_note ?part_type_label

                      OPTIONAL {
                        ?book ecrm:P1_is_identified_by ?identifier .
                        ?identifier ecrm:P2_has_type sphaera:customIdentifier ;
                          ecrm:P3_has_note ?custom_identifier .
                      }

                      OPTIONAL {
                        ?assigned_part ^efrbroo:R15i_is_fragment_of?/ecrm:PC01_is_domain_of ?has_title .
                        ?has_title a ecrm:PC102_has_title ;
                        	ecrm:PC02_has_range/ecrm:P3_has_note ?part_title_in_book ;
                        	ecrm:PC02_has_range/ecrm:P70i_is_documented_in/^ecrm:P128_carries ?book .
                    	}

                      OPTIONAL {
                        ?assigned_part efrbroo:R15i_is_fragment_of ?fragment_original .
                        ?fragment_original a ?fragment_original_part_class .
                        VALUES ( ?fragment_original_part_class ) {
                         ( sphaera:Part )
                         ( sphaera:Part_Adaption )
                       }
                       BIND(\"Fragment\" as ?is_fragment)
                      }

                      OPTIONAL {
                        ?assigned_part ecrm:P165_incorporates/ecrm:P72_has_language/ecrm:P3_has_note ?translated_language
                      }

                      OPTIONAL {
                        ?book ecrm:P128_carries/efrbroo:R24i_was_created_through/ecrm:P4_has_time-span ?date_published .

                        OPTIONAL {
                          ?date_published ecrm:P3_has_note ?date_published_text .
                        }
                        OPTIONAL {
                          ?date_published ecrm:P82a_begin_of_the_beginning ?date_published_from .
                        }
                      }

                    	VALUES ( ?part_type ) {
                          ( sphType:translation )
                          ( sphType:originalPart )
                          ( sphType:annotatedPart )
                      }

                      BIND( IF( ?part_type = sphType:originalPart, \"\", \"true\") as ?is_adaption )
                  }"
                  ,
                  "layout":{
                    "options":{
                      "resultsPerPage" : 20,
                      "showFilter" : true
                    }
                  },
                  "columnConfiguration" : [
                		{
                			"displayName" : "Book",
                      "variableName" : "book_short_title",
                			"cellTemplate" : "<semantic-link uri=\"http://sphaera.mpiwg-berlin.mpg.de/resource/viewBook\" urlqueryparam-bookiri=\"{{book.value}}\">{{book_short_title.value}}</semantic-link>"
                		},
                		{
                			"displayName" : "Part",
                      "variableName" : "assigned_part",
                			"cellTemplate" : "
                      {{#if is_adaption.value}}
                        {{#if is_fragment.value}}
                          <semantic-link uri=\":viewAdaption\" urlqueryparam-adaptioniri=\"{{fragment_original.value}}\">{{assigned_part_title.value}}</semantic-link>
                        {{else}}
                          <semantic-link uri=\":viewAdaption\" urlqueryparam-adaptioniri=\"{{assigned_part.value}}\">{{assigned_part_title.value}}</semantic-link>
                        {{/if}}
                      {{else}}
                        {{#if is_fragment.value}}
                          <semantic-link
                            [[#if workaround]]
                              uri=\":viewPart\"
                            [[else]]
                              uri=\":viewPart-2\"
                            [[/if]]
                            urlqueryparam-partiri=\"{{fragment_original.value}}\">
                            {{assigned_part_title.value}}
                          </semantic-link>
                        {{else}}
                          <semantic-link
                            [[#if workaround]]
                              uri=\":viewPart\"
                            [[else]]
                              uri=\":viewPart-2\"
                            [[/if]]
                            urlqueryparam-partiri=\"{{assigned_part.value}}\">
                            {{assigned_part_title.value}}
                          </semantic-link>
                        {{/if}}
                      {{/if}}
                      "
                		},
                		{
                			"displayName" : "Part Title in Book",
                      "variableName" : "part_title_in_book"
                		},
                		{
                			"displayName" : "On page",
                      "variableName" : "page_from",
                      "cellTemplate" : "
                        {{#if page_from_page.value}}
                          <semantic-link
                            uri=\":viewPage\"
                            urlqueryparam-pageiri=\"{{page_from_page.value}}\"
                          >{{page_from.value}}</semantic-link>
                        {{else}}
                          {{page_from.value}}
                        {{/if}}
                      "
                		},
                		{
                			"displayName" : "Part Type",
                      "variableName" : "part_type_label"
                		},
                		{
                			"displayName" : "&nbsp",
                      "cellTemplate" : "{{#if is_fragment.value}}Fragment {{/if}}{{#if translated_language.value}} translated into {{translated_language.value}}{{/if}}"
                		},
                		{
                			"displayName" :  "Date Published",
                      "variableName" : "year_published_from",
                      "cellTemplate" : "{{#if date_published_text.value}}{{date_published_text.value}}{{else}}{{year_published_from.value}}{{/if}}"
                		},
                		{
                			"displayName" :  "Custom Identifier",
                      "variableName" : "custom_identifier"
                		}
                  ]
                }'
              >
              </semantic-table>

            </dd>

            <!-- Adaptions -->
            <semantic-query
              query='SELECT ?adaption WHERE {

                ?adaption a sphaera:Part_Adaption ;
                  ecrm:P165_incorporates/(efrbroo:R3i_realises/^efrbroo:R40i_is_representative_expression_for)? ?part ;
                BIND(<[[urlParam "partiri"]]> as ?part)
              }'
              template='<dt>
                Adapted
              </dt>'
            ></semantic-query>
            <dd>
              <semantic-table
                config='{
                  "query" : "SELECT
                    ?adaption
                    ?adaption_label
                    ?creator
                    ?creator_name
                    (COUNT(?book) as ?num_books)
                    (GROUP_CONCAT(DISTINCT ?adaption_type; SEPARATOR=\", \") as ?adaption_types)
                  WHERE {
                  ?adaption a sphaera:Part_Adaption ;
                    ecrm:P2_has_type/ecrm:P3_has_note ?adaption_type ;
                    ecrm:P165_incorporates/(efrbroo:R3i_realises/^efrbroo:R40i_is_representative_expression_for)? ?part ;
                      ecrm:P3_has_note ?adaption_label .

                  OPTIONAL {
                    ?adaption efrbroo:R17i_was_created_by/ecrm:PC01_is_domain_of/ecrm:PC02_has_range ?creator .
                    ?creator ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?creator_label.
                  }

                  OPTIONAL {
                    ?book ecrm:P128_carries/ecrm:P165_incorporates/ecrm:P148_has_component ?adaption .
                  }
                  [[> :queryFormatName input="?creator_label" output="?creator_name" escape="true"]]
                  BIND(<[[urlParam "partiri"]]> as ?part)
                } GROUP BY ?adaption ?adaption_label ?creator ?creator_name ",
                "layout":{
                  "options":{
                    "resultsPerPage" : 20,
                    "showFilter" : false
                  }
                },
                "columnConfiguration" : [
                  {
                    "displayName" : "Creator",
                    "variableName" : "creator",
                    "cellTemplate" : "Adapted by <semantic-link uri=\":viewPerson\" urlqueryparam-personiri=\"{{creator.value}}\">{{creator_name.value}}</semantic-link>"
                  },
                  {
                    "displayName" : "Part Adaption",
                    "variableName" : "adaption",
                    "cellTemplate" : "in <semantic-link uri=\":viewAdaption\" urlqueryparam-adaptioniri=\"{{adaption.value}}\">{{adaption_label.value}}</semantic-link>"
                  },
                  {
                    "displayName" : "Type",
                    "variableName" : "adaption_types"
                  },
                  {
                    "displayName" : "Appears in books",
                    "variableName" : "num_books"
                  }
                ]
              }'
              >
              </semantic-table>
            </dd>

            <!-- Influenced by -->
            <semantic-query
              query='SELECT ?part WHERE {
                ?event ecrm:P15_was_influenced_by ?part .
                BIND(<[[urlParam "partiri"]]/event> as ?event)
              }'
              template='<dt>
                Influenced by
              </dt>'
            ></semantic-query>
            <dd>
              <semantic-table
                config='{
                  "query" : "SELECT ?part ?part_label (GROUP_CONCAT(?part_author; SEPARATOR=\", \") as ?part_authors) WHERE {
                    ?event ecrm:P15_was_influenced_by ?part .
                    ?part a ?part_type ;
                      ecrm:P3_has_note ?part_label .

                    OPTIONAL {
                      ?part efrbroo:R17i_was_created_by/ecrm:PC01_is_domain_of ?carried_out_by .
                      ?carried_out_by a ecrm:PC14_carried_out_by ;
                  		ecrm:PC02_has_range/ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?part_author .
                    }

                    VALUES ( ?part_type ) {
                        ( sphaera:Part )
                        ( sphaera:Part_Adaption )
                    }
                    BIND(<[[urlParam "partiri"]]/event> as ?event)
                  } GROUP BY ?part ?part_label",

                  "layout":{
                    "options":{
                      "resultsPerPage" : 20,
                      "showFilter" : false
                    }
                  },

                  "columnConfiguration" : [
                    {
                      "displayName" : "Part",
                      "variableName" : "part",
                      "cellTemplate" : "<semantic-link
                        [[#if workaround]]
                          uri=\":viewPart\"
                        [[else]]
                          uri=\":viewPart-2\"
                        [[/if]]
                        urlqueryparam-partiri=\"{{part.value}}\">
                        {{part_label.value}}
                        </semantic-link>"
                    },
                    {
                      "displayName" : "Authors",
                      "variableName" : "part_authors"
                    }
                  ]
                }'>
              </semantic-table>
            </dd>

            <!-- Influenced (reverse of influenced by) -->
            <semantic-query
              query='SELECT ?part WHERE {
                ?event ecrm:P15_was_influenced_by ?part .
                BIND(<[[urlParam "partiri"]]> as ?part)
              }'
              template='<dt>
                Influenced
              </dt>'
            ></semantic-query>
            <dd>
              <semantic-table
                config='{
                  "query" : "SELECT ?influenced_part ?influenced_part_label (GROUP_CONCAT(?influenced_part_author_label; SEPARATOR=\", \") as ?influenced_part_authors) WHERE {
                    ?event ecrm:P15_was_influenced_by ?part ;
                      ^efrbroo:R17i_was_created_by ?influenced_part .

                    ?influenced_part a ?part_type ;
                      ecrm:P3_has_note ?influenced_part_label .

                    OPTIONAL {
                      ?influenced_part efrbroo:R17i_was_created_by/ecrm:PC01_is_domain_of ?carried_out_by .
                      ?carried_out_by a ecrm:PC14_carried_out_by ;
                  		ecrm:PC02_has_range/ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?influenced_part_author .
                      [[> :queryFormatName input="?influenced_part_author" output="?influenced_part_author_label" escape="true"]]
                    }

                    VALUES ( ?part_type ) {
                        ( sphaera:Part )
                        ( sphaera:Part_Adaption )
                    }
                    BIND(<[[urlParam "partiri"]]> as ?part)
                  } GROUP BY ?influenced_part ?influenced_part_label",

                  "layout":{
                    "options":{
                      "resultsPerPage" : 20,
                      "showFilter" : false
                    }
                  },

                  "columnConfiguration" : [
                    {
                      "displayName" : "Part",
                      "variableName" : "influenced_part",
                      "cellTemplate" : "<semantic-link
                        [[#if workaround]]
                          uri=\":viewPart\"
                        [[else]]
                          uri=\":viewPart-2\"
                        [[/if]]
                        urlqueryparam-partiri=\"{{influenced_part.value}}\">
                        {{influenced_part_label.value}}
                        </semantic-link>"
                    },
                    {
                      "displayName" : "Authors",
                      "variableName" : "influenced_part_authors"
                    }
                  ]
                }'>
              </semantic-table>
            </dd>

          </dl>

          [[> :templateDOI iri="partiri"]]

          <dl>

          [[> :identifier iri="partiri"]]

        </bs-tab-pane>

        <bs-tab-pane event-key="regions">

            <semantic-table
              query="SELECT
                  [[> :queryRegionsSelect]]
                  ?book
                  ?book_label
                WHERE {
                BIND(<[[urlParam "partiri"]]> as ?part)
                ?attribute_assignment
                  sphaera:pageFrom ?page_from ;
                  sphaera:pageTo ?page_to ;
                  ecrm:P141_assigned/efrbroo:R15i_is_fragment_of? ?part ;
                  ecrm:P140_assigned_attribute_to/^ecrm:P165_incorporates/^ecrm:P128_carries ?book .
                FILTER(?page_num >= ?page_from && ?page_num <= ?page_to)
                [[> :queryRegionsForPage]]
                [[> :queryImageIdPattern]]
              } ORDER BY xsd:integer(?page_num)"
              number-of-displayed-rows="50"
              options='{"showFilter": false}'
              tuple-template='[[> :templatePageRegionsGrid]]'
            >
            </semantic-table>

        </bs-tab-pane>

        <bs-tab-pane event-key="meta">

          <semantic-query
            query='SELECT (CONCAT(STR(DAY(?date)),
             ".",
             STR(MONTH(?date)),
             ".",
            STR(YEAR(?date))) as ?displayDate)
            	?body
              ?body_html
              ?context
            WHERE {
              ?annotation a oa:Annotation ;
              oa:hasTarget ?part ;
              oa:hasBody/cnt:chars ?body .
              ?container <http://www.w3.org/ns/prov#wasAttributedTo> ?user ;
                  <http://www.w3.org/ns/prov#generatedAtTime> ?date;

              OPTIONAL {
                ?annotation ecrm:P3_has_note ?context .
              }
              BIND(<[[urlParam "partiri"]]> as ?part)
              BIND(URI(CONCAT(STR(?annotation), "/container")) as ?container)
              BIND(REPLACE(?body,"\n","<br>") as ?body_html)
            } ORDER BY ?date'

            template='<dl>
              {{#each bindings}}
                <dt>
                  {{displayDate.value}}
                </dt>
                <dd>
                  {{{body_html.value}}}
                  {{#if context.value}}
                    <p><small>{{context.value}}</small></p>
                  {{/if}}
                </dd>
              {{/each}}
            </dl>'

            no-result-template='<p>No annotations. [[#if (hasPermission "forms:ldp:*")]]<semantic-link uri=":createAnnotation" urlqueryparam-resourceiri="[[urlParam "partiri"]]">Add Annotation</semantic-link>[[/if]]</p>'

          >
          </semantic-query>

        </bs-tab-pane>

      </bs-tab-content>
    </div>
  </bs-row>
</bs-tab-container>

[[> :footer]]
